Index: trunk/LMDZ.TITAN/libf/muphytitan/mmp_optics.f90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/mmp_optics.f90	(revision 1897)
+++ trunk/LMDZ.TITAN/libf/muphytitan/mmp_optics.f90	(revision 1897)
@@ -0,0 +1,383 @@
+! Copyright 2017 Université de Reims Champagne-Ardenne 
+! Contributor: J. Burgalat (GSMA, URCA)
+! email of the author : jeremie.burgalat@univ-reims.fr
+! 
+! This software is a computer program whose purpose is to compute
+! microphysics processes using a two-moments scheme.
+! 
+! This library is governed by the CeCILL license under French law and
+! abiding by the rules of distribution of free software.  You can  use, 
+! modify and/ or redistribute the software under the terms of the CeCILL
+! license as circulated by CEA, CNRS and INRIA at the following URL
+! "http://www.cecill.info". 
+! 
+! As a counterpart to the access to the source code and  rights to copy,
+! modify and redistribute granted by the license, users are provided only
+! with a limited warranty  and the software's author,  the holder of the
+! economic rights,  and the successive licensors  have only  limited
+! liability. 
+! 
+! In this respect, the user's attention is drawn to the risks associated
+! with loading,  using,  modifying and/or developing or reproducing the
+! software by the user in light of its specific status of free software,
+! that may mean  that it is complicated to manipulate,  and  that  also
+! therefore means  that it is reserved for developers  and  experienced
+! professionals having in-depth computer knowledge. Users are therefore
+! encouraged to load and test the software's suitability as regards their
+! requirements in conditions enabling the security of their systems and/or 
+! data to be ensured and,  more generally, to use and operate it in the 
+! same conditions as regards security. 
+! 
+! The fact that you are presently reading this means that you have had
+! knowledge of the CeCILL license and that you accept its terms.
+
+!! file: mmp_optics.f90
+!! summary: Interface for YAMMS aerosols optical properties calculations.
+!! author: J. Burgalat
+!! date: 2017
+MODULE MMP_OPTICS
+  !! Optical properties of spherical/fractal aerosols using moments
+  !!
+  !!
+  !! The module contains an initialization function, [mmp_optics(module):mmp_init_aer_optics(function)],
+  !! that must be called before any calls of the other methods. On failure, it returns .false. and
+  !! consequently, all calls to the other methods will fail !
+  !!
+  !! If openMP is enabled the call to [mmp_optics(module):mmp_init_aer_optics(function)] should be
+  !! done by a single thread.
+  !!
+  !! Then the module provides 4 four public methods to compute optical properties in infrared and
+  !! visible channels as a function of moments of the size-distribution:
+  !! 
+  !! - EXT, the total extinction opacity.
+  !! - SSA, the single scattering albedo.
+  !! - ASF, the asymetry factor.
+  !!
+  !! Fractals and spherical aerosols are calculated sperately, but each EXT, SSA and ASF should be added
+  !! to get the global optical properties.
+  USE MMP_GLOBALS
+  USE DATASETS
+
+  IMPLICIT NONE
+
+  PRIVATE
+  PUBLIC :: mmp_initialize_optics
+  PUBLIC :: mmp_sph_optics_vis,mmp_sph_optics_ir
+  PUBLIC :: mmp_fra_optics_vis,mmp_fra_optics_ir
+
+  ! OPTICAL PROPERTIES !
+
+  !> Extinction opacty table (spherical,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: ext_s_i
+  !> Single scattering albedo table (spherical,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: sca_s_i
+  !> Asymetry factor table (spherical,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: asf_s_i
+  !> Extinction opacty table (fractal,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: ext_f_i
+  !> Single scattering albedo table (fractal,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: sca_f_i
+  !> Asymetry factor table (fractal,IR).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: asf_f_i
+
+  !> Extinction opacty table (spherical,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: ext_s_v
+  !> Single scattering albedo table (spherical,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: sca_s_v
+  !> Asymetry factor table (spherical,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: asf_s_v
+  !> Extinction opacty table (fractal,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: ext_f_v
+  !> Single scattering albedo table (fractal,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: sca_f_v
+  !> Asymetry factor table (fractal,VIS).
+  REAL(kind=8), DIMENSION(:,:), ALLOCATABLE, SAVE :: asf_f_v
+
+
+  INTEGER, SAVE      :: mmp_nrc    = -1  !! Size of radius grid.
+
+  !> Characteristic radius grid
+  REAL(kind=8), DIMENSION(:), ALLOCATABLE, SAVE :: mmp_rc
+
+  CONTAINS
+
+  SUBROUTINE mmp_initialize_optics(path)
+    !! Initialize optics data for aerosols optical properties computation.
+    !!
+    !! @note
+    !! If the subroutine fails to initialize parameters, the run is aborted.
+    !!
+    !! @warning
+    !! The method assumes YAMMS model has been already intialized correctly !
+    !!
+    !! @warning
+    !! If OpenMP is activated, this subroutine must be called in an $OMP SINGLE statement as it 
+    !! initializes global variables that are not thread private.
+    !!
+    !! '''
+    !! !$OMP SINGLE
+    !! call mmp_initialize(...)
+    !! !$OMP END SINGLE
+    CHARACTER(len=*), INTENT(in) :: path !! Path of NetCDF look-up tables file.
+    LOGICAL :: ret
+    WRITE(*,'(a)') "*** mmp_init_aer_optics speaking ***"
+    WRITE(*,'(a)') "I'm about to initialize look-up tables of aerosols optical properties."
+    WRITE(*,'(a)') "If something's wrong... I will abort the program !"
+    IF (.NOT.mm_ini) THEN
+      call abort_program(error("[mmp_init_aer_optics] Too bad mmp_initialize has not been called yet !",2))
+    ENDIF
+    !  look-up tables
+    ret = read_lookup_tables(path)
+    IF (.NOT.ret) &
+      call abort_program(error("[mmp_init_aer_optics] Failed to retrieve data.",2))
+  END SUBROUTINE mmp_initialize_optics
+
+  FUNCTION mmp_sph_optics_vis(M0,M3,iwn,ext,sca,ssa,asf) RESULT(ret)
+    !! Compute optical properties of the spherical mode in the visible range.
+    REAL(kind=mm_wp), INTENT(in)  :: M0  !! 0th order moment of the spherical mode (m-2).
+    REAL(kind=mm_wp), INTENT(in)  :: M3  !! 3rd order moment of the spherical mode (m3.m-2).
+    INTEGER, INTENT(in)           :: iwn !! Index of the wavenumber to compute
+    REAL(kind=mm_wp), INTENT(out) :: ext !! Extinction opacity.
+    REAL(kind=mm_wp), INTENT(out) :: sca !! Scattering.
+    REAL(kind=mm_wp), INTENT(out) :: ssa !! Single scattering albedo. 
+    REAL(kind=mm_wp), INTENT(out) :: asf !! Asymetry factor.
+    LOGICAL                       :: ret !! true on success, false otherwise.
+    INTEGER          :: i,ridx
+    REAL(kind=mm_wp) :: rc1,rc2,rx,rc
+    ret = .false.
+    IF (mmp_nrc == -1) RETURN
+    ret = .true.
+    rc = mm_get_rcs(M0,M3)
+    ridx = mmp_nrc
+    DO i=1, mmp_nrc
+      IF (rc < mmp_rc(i)) THEN
+        ridx = i-1
+        EXIT
+      ENDIF
+    ENDDO
+    IF (ridx == 0) THEN
+      ! out of range lower bound
+      ext = ext_s_v(1,iwn)
+      sca = sca_s_v(1,iwn)
+      asf = asf_s_v(1,iwn)
+      ssa = sca/ext
+    ELSE IF (ridx == mmp_nrc) THEN
+      ! out of range upper bound
+      ext = ext_s_v(mmp_nrc,iwn)
+      sca = sca_s_v(mmp_nrc,iwn)
+      asf = asf_s_v(mmp_nrc,iwn)
+      ssa = sca/ext
+    ELSE
+      ! in range: interpolate
+      rc1 = mmp_rc(ridx) ; rc2 = mmp_rc(ridx+1)
+      rx = (rc-rc1)/(rc2-rc1)
+      ext = exp(log(ext_s_v(ridx,iwn))*(1d0-rx) + log(ext_s_v(ridx+1,iwn))*rx)
+      sca = exp(log(sca_s_v(ridx,iwn))*(1d0-rx) + log(sca_s_v(ridx+1,iwn))*rx)
+      asf = asf_s_v(ridx,iwn)*(1d0-rx) + asf_s_v(ridx+1,iwn)*rx
+      ssa = sca/ext
+    ENDIF
+    ! scale by M0
+    ext = ext * M0
+    RETURN
+  END FUNCTION mmp_sph_optics_vis
+
+  FUNCTION mmp_sph_optics_ir(M0,M3,iwn,ext,sca,ssa,asf) RESULT(ret)
+    !! Compute optical properties of the spherical mode in the infra-red range.
+    REAL(kind=mm_wp), INTENT(in)  :: M0  !! 0th order moment of the spherical mode (m-2).
+    REAL(kind=mm_wp), INTENT(in)  :: M3  !! 3rd order moment of the spherical mode (m3.m-2).
+    INTEGER, INTENT(in)           :: iwn !! Index of the wavenumber to compute
+    REAL(kind=mm_wp), INTENT(out) :: ext !! Extinction opacity.
+    REAL(kind=mm_wp), INTENT(out) :: sca !! Scattering.
+    REAL(kind=mm_wp), INTENT(out) :: ssa !! Single scattering albedo. 
+    REAL(kind=mm_wp), INTENT(out) :: asf !! Asymetry factor.
+    LOGICAL                       :: ret !! true on success, false otherwise.
+    INTEGER          :: i,ridx
+    REAL(kind=mm_wp) :: rc1,rc2,rx,rc
+    ret = .false.
+    IF (mmp_nrc == -1) RETURN
+    ret = .true.
+    rc = mm_get_rcs(M0,M3)
+    ridx = mmp_nrc
+    DO i=1, mmp_nrc
+      IF (rc < mmp_rc(i)) THEN
+        ridx = i-1
+        EXIT
+      ENDIF
+    ENDDO
+    IF (ridx == 0) THEN
+      ! out of range lower bound
+      ext = ext_s_i(1,iwn)
+      sca = sca_s_i(1,iwn)
+      asf = asf_s_i(1,iwn)
+      ssa = sca/ext
+    ELSE IF (ridx == mmp_nrc) THEN
+      ! out of range upper bound
+      ext = ext_s_i(mmp_nrc,iwn)
+      sca = sca_s_i(mmp_nrc,iwn)
+      asf = asf_s_i(mmp_nrc,iwn)
+      ssa = sca/ext
+    ELSE
+      ! in range: interpolate
+      rc1 = mmp_rc(ridx) ; rc2 = mmp_rc(ridx+1)
+      rx = (rc-rc1)/(rc2-rc1)
+      ext = exp(log(ext_s_i(ridx,iwn))*(1d0-rx) + log(ext_s_i(ridx+1,iwn))*rx)
+      sca = exp(log(sca_s_i(ridx,iwn))*(1d0-rx) + log(sca_s_i(ridx+1,iwn))*rx)
+      asf = asf_s_i(ridx,iwn)*(1d0-rx) + asf_s_i(ridx+1,iwn)*rx
+      ssa = sca/ext
+    ENDIF
+    ! scale by M0
+    ext = ext * M0
+    RETURN
+  END FUNCTION mmp_sph_optics_ir
+
+  FUNCTION mmp_fra_optics_vis(M0,M3,iwn,ext,sca,ssa,asf) RESULT(ret)
+    !! Compute optical properties of the spherical mode in the visible range.
+    REAL(kind=mm_wp), INTENT(in)  :: M0  !! 0th order moment of the fractal mode (m-2).
+    REAL(kind=mm_wp), INTENT(in)  :: M3  !! 3rd order moment of the fractal mode (m3.m-2).
+    INTEGER, INTENT(in)           :: iwn !! Index of the wavenumber to compute.
+    REAL(kind=mm_wp), INTENT(out) :: ext !! Extinction opacity.
+    REAL(kind=mm_wp), INTENT(out) :: sca !! Scattering.
+    REAL(kind=mm_wp), INTENT(out) :: ssa !! Single scattering albedo. 
+    REAL(kind=mm_wp), INTENT(out) :: asf !! Asymetry factor.
+    LOGICAL                       :: ret !! true on success, false otherwise.
+    INTEGER          :: i,ridx
+    REAL(kind=mm_wp) :: rc1,rc2,rx,rc
+    ret = .false.
+    IF (mmp_nrc == -1) RETURN
+    ret = .true.
+    rc = mm_get_rcs(M0,M3)
+    ridx = mmp_nrc
+    DO i=1, mmp_nrc
+      IF (rc < mmp_rc(i)) THEN
+        ridx = i-1
+        EXIT
+      ENDIF
+    ENDDO
+    IF (ridx == 0) THEN
+      ! out of range lower bound
+      ext = ext_f_v(1,iwn)
+      sca = sca_f_v(1,iwn)
+      asf = asf_f_v(1,iwn)
+      ssa = sca/ext
+    ELSE IF (ridx == mmp_nrc) THEN
+      ! out of range upper bound
+      ext = ext_f_v(mmp_nrc,iwn)
+      sca = sca_f_v(mmp_nrc,iwn)
+      asf = asf_f_v(mmp_nrc,iwn)
+      ssa = sca/ext
+    ELSE
+      ! in range: interpolate
+      rc1 = mmp_rc(ridx) ; rc2 = mmp_rc(ridx+1)
+      rx = (rc-rc1)/(rc2-rc1)
+      ext = exp(log(ext_f_v(ridx,iwn))*(1d0-rx) + log(ext_f_v(ridx+1,iwn))*rx)
+      sca = exp(log(sca_f_v(ridx,iwn))*(1d0-rx) + log(sca_f_v(ridx+1,iwn))*rx)
+      asf = asf_f_v(ridx,iwn)*(1d0-rx) + asf_f_v(ridx+1,iwn)*rx
+      ssa = sca/ext
+    ENDIF
+    ! scale by M0
+    ext = ext * M0
+    RETURN
+  END FUNCTION mmp_fra_optics_vis
+
+  FUNCTION mmp_fra_optics_ir(M0,M3,iwn,ext,sca,ssa,asf) RESULT(ret)
+    !! Compute optical properties of the spherical mode in the infra-red range.
+    REAL(kind=mm_wp), INTENT(in)  :: M0  !! 0th order moment of the spherical mode (m-2).
+    REAL(kind=mm_wp), INTENT(in)  :: M3  !! 3rd order moment of the spherical mode (m3.m-2).
+    INTEGER, INTENT(in)           :: iwn !! Index of the wavenumber to compute
+    REAL(kind=mm_wp), INTENT(out) :: ext !! Extinction opacity.
+    REAL(kind=mm_wp), INTENT(out) :: sca !! Scattering.
+    REAL(kind=mm_wp), INTENT(out) :: ssa !! Single scattering albedo. 
+    REAL(kind=mm_wp), INTENT(out) :: asf !! Asymetry factor.
+    LOGICAL                       :: ret !! true on success, false otherwise.
+    INTEGER          :: i,ridx
+    REAL(kind=mm_wp) :: rc1,rc2,rx,rc
+    ret = .false.
+    IF (mmp_nrc == -1) RETURN
+    ret = .true.
+    rc = mm_get_rcs(M0,M3)
+    ridx = mmp_nrc
+    DO i=1, mmp_nrc
+      IF (rc < mmp_rc(i)) THEN
+        ridx = i-1
+        EXIT
+      ENDIF
+    ENDDO
+    IF (ridx == 0) THEN
+      ! out of range lower bound
+      ext = ext_f_i(1,iwn)
+      sca = sca_f_i(1,iwn)
+      asf = asf_f_i(1,iwn)
+      ssa = sca/ext
+    ELSE IF (ridx == mmp_nrc) THEN
+      ! out of range upper bound
+      ext = ext_f_i(mmp_nrc,iwn)
+      sca = sca_f_i(mmp_nrc,iwn)
+      asf = asf_f_i(mmp_nrc,iwn)
+      ssa = sca/ext
+    ELSE
+      ! in range: interpolate
+      rc1 = mmp_rc(ridx) ; rc2 = mmp_rc(ridx+1)
+      rx = (rc-rc1)/(rc2-rc1)
+      ext = exp(log(ext_f_i(ridx,iwn))*(1d0-rx) + log(ext_f_i(ridx+1,iwn))*rx)
+      sca = exp(log(sca_f_i(ridx,iwn))*(1d0-rx) + log(sca_f_i(ridx+1,iwn))*rx)
+      asf = asf_f_i(ridx,iwn)*(1d0-rx) + asf_f_i(ridx+1,iwn)*rx
+      ssa = sca/ext
+    ENDIF
+    ! scale by M0
+    ext = ext * M0
+    RETURN
+  END FUNCTION mmp_fra_optics_ir
+
+  FUNCTION read_lookup_tables(path) RESULT(ret)
+    !! Read look-up tables.
+    CHARACTER(len=*), INTENT(in) :: path !! Path of the look-up tables netcdf file.
+    LOGICAL                      :: ret  !! .true. on success, .false. otherwise.
+    REAL(kind=mm_wp), DIMENSION(:), ALLOCATABLE :: sigmas_vi,sigmas_ir
+
+    TYPE(DSET2D) :: dset
+    ! data(nrc,ni|nv)
+    ! INFRARED
+    ret = read_dset(path,"ext_s_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'ext_s_i' table" ; RETURN ; ENDIF 
+    ext_s_i = dset%data ; sigmas_ir = dset%y ; mmp_rc = dset%x
+    ret = read_dset(path,"ext_f_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'ext_f_i' table" ; RETURN ; ENDIF 
+    ext_f_i = dset%data 
+    ret = read_dset(path,"sca_s_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'sca_s_i' table" ; RETURN ; ENDIF 
+    sca_s_i = dset%data 
+    ret = read_dset(path,"sca_f_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'sca_f_i' table" ; RETURN ; ENDIF 
+    sca_f_i = dset%data 
+    ret = read_dset(path,"asf_s_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'asf_s_i' table" ; RETURN ; ENDIF 
+    asf_s_i = dset%data 
+    ret = read_dset(path,"asf_f_i",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'asf_f_i' table" ; RETURN ; ENDIF 
+    asf_f_i = dset%data 
+    ! VISIBLE
+    ret = read_dset(path,"ext_s_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'ext_s_v' table" ; RETURN ; ENDIF 
+    ext_s_v = dset%data ; sigmas_vi = dset%y
+    ret = read_dset(path,"ext_f_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'ext_f_v' table" ; RETURN ; ENDIF 
+    ext_f_v = dset%data 
+    ret = read_dset(path,"sca_s_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'sca_s_v' table" ; RETURN ; ENDIF 
+    sca_s_v = dset%data 
+    ret = read_dset(path,"sca_f_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'sca_f_v' table" ; RETURN ; ENDIF 
+    sca_f_v = dset%data 
+    ret = read_dset(path,"asf_s_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'asf_s_v' table" ; RETURN ; ENDIF 
+    asf_s_v = dset%data 
+    ret = read_dset(path,"asf_f_v",dset)
+    IF (.NOT.ret) THEN ; WRITE(*,'(a)') "[read_tables] cannot read 'asf_f_v' table" ; RETURN ; ENDIF 
+    asf_f_v = dset%data 
+    mmp_nrc = SIZE(mmp_rc)
+    ret = .true.
+    RETURN
+  END FUNCTION read_lookup_tables
+
+END MODULE MMP_OPTICS
+
Index: trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/callcorrk.F90	(revision 1897)
@@ -45,5 +45,5 @@
       INTEGER,INTENT(IN) :: ngrid                  ! Number of atmospheric columns.
       INTEGER,INTENT(IN) :: nlayer                 ! Number of atmospheric layers.
-      REAL,INTENT(IN) :: pq(ngrid,nlayer,nq)       ! Tracers (kg/kg_of_air).
+      REAL,INTENT(IN) :: pq(ngrid,nlayer,nq)       ! Tracers (X/m2).
       INTEGER,INTENT(IN) :: nq                     ! Number of tracers.
       REAL,INTENT(IN) :: qsurf(ngrid,nq)           ! Tracers on surface (kg.m-2).
@@ -298,5 +298,5 @@
             endif
             
-            call optcv(pq,plevrad,tmid,pmid,                       &
+            call optcv(pq(ig,:,1:nmicro),nlayer,plevrad,tmid,pmid,        &
                  dtauv,tauv,taucumv,wbarv,cosbv,tauray,taugsurf)
 
@@ -340,5 +340,5 @@
 !-----------------------------------------------------------------------
 
-         call optci(pq,plevrad,tlevrad,tmid,pmid,                   &
+         call optci(pq(ig,:,1:nmicro),nlayer,plevrad,tlevrad,tmid,pmid,    &
               dtaui,taucumi,cosbi,wbari,taugsurfi)
 
Index: trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/callkeys_mod.F90	(revision 1897)
@@ -12,6 +12,9 @@
       logical,save :: callgasvis,continuum,graybody
 !$OMP THREADPRIVATE(callgasvis,continuum,graybody)
-      logical,save :: strictboundcorrk                                     
+      logical,save :: strictboundcorrk
 !$OMP THREADPRIVATE(strictboundcorrk)
+      logical,save :: uncoupl_optic_haze
+!$OMP THREADPRIVATE(uncoupl_optic_haze)
+
       logical,save :: callchim, callmufi, callclouds
 !$OMP THREADPRIVATE(callchim,callmufi,callclouds)
@@ -45,9 +48,8 @@
 !$OMP THREADPRIVATE(iddist,iradia,startype)
       
-      real,save :: df_mufi, rm_mufi, rho_aer_mufi
       real,save :: p_prod, tx_prod, rc_prod
       real,save :: air_rad
-!$OMP THREADPRIVATE(df_mufi, rm_mufi, rho_aer_mufi,p_prod,tx_prod,rc_prod,air_rad)
-
+!$OMP THREADPRIVATE(p_prod,tx_prod,rc_prod,air_rad)
+      
       real,save :: szangle
 !$OMP THREADPRIVATE(szangle)
Index: trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/calmufi.F90	(revision 1897)
@@ -1,6 +1,8 @@
+
+
 SUBROUTINE calmufi(plev, zlev, play, zlay, temp, pq, zdq)
   !! Interface subroutine to YAMMS model for Titan LMDZ GCM.
   !!
-  !! The subroutine computes the microphysics processes for a single vertical column.
+  !! The subroutine computes the microphysics processes for a si:le vertical column.
   !!
   !! - All input vectors are assumed to be defined from GROUND to TOP of the atmosphere.
@@ -52,5 +54,4 @@
 
   INTEGER :: ilon, i,nices
-
   INTEGER :: nlon,nlay
 
@@ -89,6 +90,5 @@
     ! Convert tracers to extensive ( except for gazs where we work with molar mass ratio )
     ! We suppose a given order of tracers !
-    int2ext(:) = ( plev(ilon,1:nlay) - plev(ilon,2:nlay+1) ) / g
-
+    int2ext(:) = ( plev(ilon,1:nlay)-plev(ilon,2:nlay+1) ) / g
     m0as(:) = pq(ilon,:,1) * int2ext(:)
     m3as(:) = pq(ilon,:,2) * int2ext(:)
@@ -97,13 +97,12 @@
     
     if (callclouds) then ! if call clouds
-      dm0n(:) = pq(ilon,:,5) * int2ext(:)
-      dm3n(:) = pq(ilon,:,6) * int2ext(:)
+      m0n(:) = pq(ilon,:,5) * int2ext(:)
+      m3n(:) = pq(ilon,:,6) * int2ext(:)
       do i=1,nices
-        dm3i(:,nices) = pq(ilon,:,6+i) * int2ext(:)
-        dgazs(:,i)    = pq(ilon,:,ices_indx(i)) * rat_mmol(ices_indx(i)) ! For gazs we work on the full tracer array !!
+        m3i(:,nices) = pq(ilon,:,6+i) * int2ext(:)
+        gazs(:,i)    = pq(ilon,:,ices_indx(i)) * rat_mmol(ices_indx(i)) ! For gazs we work on the full tracer array !!
         ! We use the molar mass ratio from GCM in case there is discrepancy with the mm one
       enddo
     endif
-
 
     ! Initialize YAMMS atmospheric column
@@ -135,5 +134,5 @@
     ! Convert tracers back to intensives ( except for gazs where we work with molar mass ratio )
     ! We suppose a given order of tracers !
-
+ 
     zdq(ilon,:,1) = dm0as(:) / int2ext(:)
     zdq(ilon,:,2) = dm3as(:) / int2ext(:)
@@ -150,5 +149,4 @@
       enddo
     endif
-
   END DO ! loop on ilon
 
Index: trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/inifis_mod.F90	(revision 1897)
@@ -377,18 +377,9 @@
      endif
 
-     write(*,*) "Fractal dimension ?"
-     df_mufi=2.0 ! default value
-     call getin_p("df_mufi",df_mufi)
-     write(*,*)" df_mufi = ",df_mufi
-
-     write(*,*) "Monomer radius (m) ?"
-     rm_mufi=6.66e-08 ! default value
-     call getin_p("rm_mufi",rm_mufi)
-     write(*,*)" rm_mufi = ",rm_mufi
-
-     write(*,*) "Aerosol density (kg.m-3)?"
-     rho_aer_mufi=1.e3 ! default value
-     call getin_p("rho_aer_mufi",rho_aer_mufi)
-     write(*,*)" rho_aer_mufi = ",rho_aer_mufi
+     write(*,*) "Disable the coupling of microphysics within rad. transf. ?"
+     write(*,*) "If disabled we will assume a planetwide vert. profile of extinction ..."
+     uncoupl_optic_haze=.true. ! default value - true as long as the microphysics is bugged
+     call getin_p("uncoupl_optic_haze",uncoupl_optic_haze)
+     write(*,*)" uncoupl_optic_haze = ",uncoupl_optic_haze
 
      write(*,*) "Pressure level of aer. production (Pa) ?"
Index: trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/inimufi.F90	(revision 1897)
@@ -2,6 +2,5 @@
 
   use mmp_gcm
-  use callkeys_mod, only : callclouds, df_mufi, &
-        rm_mufi, rho_aer_mufi, p_prod, tx_prod, rc_prod, air_rad
+  use callkeys_mod, only : callclouds, p_prod, tx_prod, rc_prod, air_rad
   use tracer_h
   use comcstfi_mod, only : g, rad, mugaz
@@ -42,4 +41,7 @@
   logical :: err
 
+  ! PATCH : YAMMS now allows to enable/disable effective g computations:
+  !  In the library it defaults to .true., in the GCM we do not want it !
+  mm_use_effg = .false.
 
   !----------------------------------------------------
@@ -47,5 +49,5 @@
   ! ---------------------------------------------------
 
-   call mmp_initialize(ptimestep,df_mufi,rm_mufi,rho_aer_mufi,p_prod,tx_prod,rc_prod, &
+   call mmp_initialize(ptimestep,p_prod,tx_prod,rc_prod, &
         rad,g,air_rad,mugaz,callclouds,config_mufi)
 
Index: trunk/LMDZ.TITAN/libf/phytitan/optci.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optci.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/optci.F90	(revision 1897)
@@ -1,3 +1,3 @@
-subroutine optci(PQ,PLEV,TLEV,TMID,PMID,      &
+subroutine optci(PQO,NLAY,PLEV,TLEV,TMID,PMID,      &
      DTAUI,TAUCUMI,COSBI,WBARI,TAUGSURF)
 
@@ -6,5 +6,8 @@
   use gases_h
   use comcstfi_mod, only: g, r
-  use callkeys_mod, only: continuum,graybody
+  use callkeys_mod, only: continuum,graybody,callclouds,callmufi, uncoupl_optic_haze
+  use tracer_h, only : nmicro,nice
+  use MMP_OPTICS
+
   implicit none
 
@@ -34,5 +37,6 @@
   ! Input/Output
   !==========================================================
-  REAL*8, INTENT(IN)  :: PQ ! Tracers (kg/kg_of_air).
+  REAL*8, INTENT(IN)  :: PQO(nlay,nmicro) ! Tracers (X/m2).
+  INTEGER, INTENT(IN) :: NLAY             ! Number of pressure layers (for pqo)
   REAL*8, INTENT(IN)  :: PLEV(L_LEVELS), TLEV(L_LEVELS)
   REAL*8, INTENT(IN)  :: TMID(L_LEVELS), PMID(L_LEVELS)
@@ -86,4 +90,10 @@
   integer interm
 
+  real*8 m0as,m3as,m0af,m3af
+  real*8 ext_s,sca_s,ssa_s,asf_s
+  real*8 ext_f,sca_f,ssa_f,asf_f
+  logical,save :: firstcall=.true.
+  !$OMP THREADPRIVATE(firstcall)
+
   !! AS: to save time in computing continuum (see bilinearbig)
   IF (.not.ALLOCATED(indi)) THEN
@@ -127,7 +137,26 @@
         ilay = k / 2 ! int. arithmetic => gives the gcm layer index
         
-        !================= Titan customisation ========================================
-        call disr_haze(dz(k),plev(k),wnoi(nw),dhaze_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
-        ! =============================================================================
+        ! Optical coupling of YAMMS is plugged but inactivated for now
+        ! as long as the microphysics only isn't fully debugged -- JVO 01/18
+        IF (callmufi .AND. (.NOT. uncoupl_optic_haze)) THEN
+          m0as = pqo(ilay,1)
+          m3as = pqo(ilay,2)
+          m0af = pqo(ilay,3)
+          m3af = pqo(ilay,4)
+
+          IF (.NOT.mmp_sph_optics_ir(m0as,m3as,nw,ext_s,sca_s,ssa_s,asf_s)) &
+          CALL abort_gcm("optcv", "Fatal error in mmp_sph_optics_ir", 12)
+          IF (.NOT.mmp_fra_optics_ir(m0af,m3af,nw,ext_f,sca_f,ssa_f,asf_f)) &
+          CALL abort_gcm("optcv", "Fatal error in mmp_fra_optics_ir", 12)
+          dhaze_T(k,nw) = ext_s+ext_f
+          SSA_T(k,nw)   = (sca_s+sca_f)/dhaze_T(k,nw)
+          ASF_T(k,nw)   = (asf_s*sca_s + asf_f*sca_f) /(sca_s+sca_f)
+          IF (callclouds.and.firstcall) & 
+            WRITE(*,*) 'WARNING: In optci, optical properties &
+                       &calculations are not implemented yet'
+        ELSE
+          ! Call fixed vertical haze profile of extinction - same for all columns
+          call disr_haze(dz(k),plev(k),wnoi(nw),dhaze_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
+        ENDIF
 
         DCONT = 0.0d0 ! continuum absorption
@@ -401,4 +430,6 @@
 ! ==============================================================================  
 
+  if(firstcall) firstcall = .false.
+
   return
 
Index: trunk/LMDZ.TITAN/libf/phytitan/optcv.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/optcv.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/optcv.F90	(revision 1897)
@@ -1,3 +1,3 @@
-SUBROUTINE OPTCV(PQ,PLEV,TMID,PMID,  &
+SUBROUTINE OPTCV(PQO,NLAY,PLEV,TMID,PMID,  &
      DTAUV,TAUV,TAUCUMV,WBARV,COSBV,TAURAY,TAUGSURF)
 
@@ -6,5 +6,7 @@
   use gases_h
   use comcstfi_mod, only: g, r
-  use callkeys_mod, only: continuum,graybody,callgasvis
+  use callkeys_mod, only: continuum,graybody,callgasvis,callclouds,callmufi,uncoupl_optic_haze
+  use tracer_h, only: nmicro,nice
+  use MMP_OPTICS
 
   implicit none
@@ -41,5 +43,6 @@
   ! Input/Output
   !==========================================================
-  REAL*8, INTENT(IN)  :: PQ ! Tracers (kg/kg_of_air).
+  REAL*8, INTENT(IN)  :: PQO(nlay,nmicro) ! Tracers (X/m2).
+  INTEGER, INTENT(IN) :: NLAY             ! Number of pressure layers (for pqo)
   REAL*8, INTENT(IN)  :: PLEV(L_LEVELS)
   REAL*8, INTENT(IN)  :: TMID(L_LEVELS), PMID(L_LEVELS)
@@ -97,4 +100,11 @@
   integer interm
 
+  real*8 m0as,m3as,m0af,m3af
+  real*8 ext_s,sca_s,ssa_s,asf_s
+  real*8 ext_f,sca_f,ssa_f,asf_f
+  logical,save :: firstcall=.true.
+  !$OMP THREADPRIVATE(firstcall)
+
+
   !! AS: to save time in computing continuum (see bilinearbig)
   IF (.not.ALLOCATED(indv)) THEN
@@ -149,8 +159,27 @@
 
      do NW=1,L_NSPECTV
-
-        !================= Titan customisation ========================================
-        call disr_haze(dz(k),plev(k),wnov(nw),dhaze_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
-        ! =============================================================================
+     
+        ! Optical coupling of YAMMS is plugged but inactivated (if false) for now
+        ! as long as the microphysics only isn't fully debugged -- JVO 01/18
+        IF (callmufi .AND. (.NOT. uncoupl_optic_haze)) THEN
+          m0as = pqo(ilay,1)
+          m3as = pqo(ilay,2)
+          m0af = pqo(ilay,3)
+          m3af = pqo(ilay,4)
+
+          IF (.NOT.mmp_sph_optics_vis(m0as,m3as,nw,ext_s,sca_s,ssa_s,asf_s)) &
+          CALL abort_gcm("optcv", "Fatal error in mmp_sph_optics_vis", 12)
+          IF (.NOT.mmp_fra_optics_vis(m0af,m3af,nw,ext_f,sca_f,ssa_f,asf_f)) &
+          CALL abort_gcm("optcv", "Fatal error in mmp_fra_optics_vis", 12)
+          dhaze_T(k,nw) = ext_s+ext_f
+          SSA_T(k,nw)   = (sca_s+sca_f)/dhaze_T(k,nw)
+          ASF_T(k,nw)   = (asf_s*sca_s + asf_f*sca_f) /(sca_s+sca_f)
+          IF (callclouds.and.firstcall) & 
+            WRITE(*,*) 'WARNING: In optcv, optical properties &
+                       &calculations are not implemented yet'
+        ELSE
+          ! Call fixed vertical haze profile of extinction - same for all columns
+          call disr_haze(dz(k),plev(k),wnov(nw),dhaze_T(k,nw),SSA_T(k,nw),ASF_T(k,nw))
+        ENDIF
          
         DRAYAER = TRAY(K,NW)
@@ -355,4 +384,5 @@
 ! ==============================================================================  
 
+  if(firstcall) firstcall = .false.
 
   return
Index: trunk/LMDZ.TITAN/libf/phytitan/setspi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/setspi.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/phytitan/setspi.F90	(revision 1897)
@@ -138,4 +138,8 @@
       end do
 !     note M=L_NSPECTI+1 after loop due to Fortran bizarreness
+!        --> No fortran bizarreness here... incrementation is performed at the end of the loop...
+!        --> then when M reached L_NSPECTI, we initialiaze the last element of each array and
+!            ... increment one last time M... tadaaaa, mystery solved !
+!            The same logic is applied on for loop in C !
 
 !=======================================================================
